import { CanActivate, ExecutionContext } from '@nestjs/common';
import { Reflector } from '@nestjs/core';
import * as casbin from 'casbin';
import { AuthZModuleOptions } from './interfaces/authz-module-options.interface';
export declare class AuthZGuard implements CanActivate {
    private readonly reflector;
    private enforcer;
    private options;
    constructor(reflector: Reflector, enforcer: casbin.Enforcer, options: AuthZModuleOptions);
    canActivate(context: ExecutionContext): Promise<boolean>;
    static asyncSome<T>(array: T[], callback: (value: T, index: number, a: T[]) => Promise<boolean>): Promise<boolean>;
    static asyncEvery<T>(array: T[], callback: (value: T, index: number, a: T[]) => Promise<boolean>): Promise<boolean>;
}
