"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("@nestjs/common");
var core_1 = require("@nestjs/core");
var authz_constants_1 = require("./authz.constants");
var casbin = require("casbin");
var common_2 = require("@nestjs/common");
var types_1 = require("./types");
var AuthZGuard = (function () {
    function AuthZGuard(reflector, enforcer, options) {
        this.reflector = reflector;
        this.enforcer = enforcer;
        this.options = options;
    }
    AuthZGuard_1 = AuthZGuard;
    AuthZGuard.prototype.canActivate = function (context) {
        return __awaiter(this, void 0, void 0, function () {
            var permissions, username_1, hasPermission_1, result, e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        permissions = this.reflector.get(authz_constants_1.PERMISSIONS_METADATA, context.getHandler());
                        if (!permissions) {
                            return [2, true];
                        }
                        username_1 = this.options.usernameFromContext(context);
                        if (!username_1) {
                            throw new common_2.UnauthorizedException();
                        }
                        hasPermission_1 = function (user, permission) { return __awaiter(_this, void 0, void 0, function () {
                            var possession, resource, action, poss;
                            var _this = this;
                            return __generator(this, function (_a) {
                                possession = permission.possession, resource = permission.resource, action = permission.action;
                                poss = [];
                                if (possession === types_1.AuthPossession.OWN_ANY) {
                                    poss.push(types_1.AuthPossession.ANY, types_1.AuthPossession.OWN);
                                }
                                else {
                                    poss.push(possession);
                                }
                                return [2, AuthZGuard_1.asyncSome(poss, function (p) { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            if (p === types_1.AuthPossession.OWN) {
                                                return [2, permission.isOwn(context)];
                                            }
                                            else {
                                                return [2, this.enforcer.enforce(user, resource, action + ":" + p)];
                                            }
                                            return [2];
                                        });
                                    }); })];
                            });
                        }); };
                        return [4, AuthZGuard_1.asyncEvery(permissions, function (permission) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                return [2, hasPermission_1(username_1, permission)];
                            }); }); })];
                    case 1:
                        result = _a.sent();
                        return [2, result];
                    case 2:
                        e_1 = _a.sent();
                        throw e_1;
                    case 3: return [2];
                }
            });
        });
    };
    AuthZGuard.asyncSome = function (array, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var i, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < array.length)) return [3, 4];
                        return [4, callback(array[i], i, array)];
                    case 2:
                        result = _a.sent();
                        if (result) {
                            return [2, result];
                        }
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3, 1];
                    case 4: return [2, false];
                }
            });
        });
    };
    AuthZGuard.asyncEvery = function (array, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var i, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < array.length)) return [3, 4];
                        return [4, callback(array[i], i, array)];
                    case 2:
                        result = _a.sent();
                        if (!result) {
                            return [2, result];
                        }
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3, 1];
                    case 4: return [2, true];
                }
            });
        });
    };
    var AuthZGuard_1;
    AuthZGuard = AuthZGuard_1 = __decorate([
        common_1.Injectable(),
        __param(1, common_1.Inject(authz_constants_1.AUTHZ_ENFORCER)),
        __param(2, common_1.Inject(authz_constants_1.AUTHZ_MODULE_OPTIONS)),
        __metadata("design:paramtypes", [core_1.Reflector, casbin.Enforcer, Object])
    ], AuthZGuard);
    return AuthZGuard;
}());
exports.AuthZGuard = AuthZGuard;
//# sourceMappingURL=authz.guard.js.map