"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("@nestjs/common");
var authz_constants_1 = require("../authz.constants");
var casbin = require("casbin");
var AuthZManagementService = (function () {
    function AuthZManagementService(enforcer) {
        this.enforcer = enforcer;
    }
    AuthZManagementService.prototype.getAllSubjects = function () {
        return this.enforcer.getAllSubjects();
    };
    AuthZManagementService.prototype.getAllNamedSubjects = function (ptype) {
        return this.enforcer.getAllNamedSubjects(ptype);
    };
    AuthZManagementService.prototype.getAllObjects = function () {
        return this.enforcer.getAllObjects();
    };
    AuthZManagementService.prototype.getAllNamedObjects = function (ptype) {
        return this.enforcer.getAllNamedObjects(ptype);
    };
    AuthZManagementService.prototype.getAllActions = function () {
        return this.enforcer.getAllActions();
    };
    AuthZManagementService.prototype.getAllNamedActions = function (ptype) {
        return this.enforcer.getAllNamedActions(ptype);
    };
    AuthZManagementService.prototype.getAllRoles = function () {
        return this.enforcer.getAllRoles();
    };
    AuthZManagementService.prototype.getAllNamedRoles = function (ptype) {
        return this.enforcer.getAllNamedRoles(ptype);
    };
    AuthZManagementService.prototype.getPolicy = function () {
        return this.enforcer.getPolicy();
    };
    AuthZManagementService.prototype.getFilteredPolicy = function (fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            fieldValues[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).getFilteredPolicy.apply(_a, __spreadArrays([fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.getNamedPolicy = function (ptype) {
        return this.enforcer.getNamedPolicy(ptype);
    };
    AuthZManagementService.prototype.getFilteredNamedPolicy = function (ptype, fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            fieldValues[_i - 2] = arguments[_i];
        }
        return (_a = this.enforcer).getFilteredNamedPolicy.apply(_a, __spreadArrays([ptype,
            fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.getGroupingPolicy = function () {
        return this.enforcer.getGroupingPolicy();
    };
    AuthZManagementService.prototype.getFilteredGroupingPolicy = function (fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            fieldValues[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).getFilteredGroupingPolicy.apply(_a, __spreadArrays([fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.getNamedGroupingPolicy = function (ptype) {
        return this.enforcer.getNamedGroupingPolicy(ptype);
    };
    AuthZManagementService.prototype.getFilteredNamedGroupingPolicy = function (ptype, fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            fieldValues[_i - 2] = arguments[_i];
        }
        return (_a = this.enforcer).getFilteredNamedGroupingPolicy.apply(_a, __spreadArrays([ptype,
            fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.hasPolicy = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        return (_a = this.enforcer).hasPolicy.apply(_a, params);
    };
    AuthZManagementService.prototype.hasNamedPolicy = function (ptype) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).hasNamedPolicy.apply(_a, __spreadArrays([ptype], params));
    };
    AuthZManagementService.prototype.addPolicy = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        return (_a = this.enforcer).addPolicy.apply(_a, params);
    };
    AuthZManagementService.prototype.addPolicies = function (rules) {
        return this.enforcer.addPolicies(rules);
    };
    AuthZManagementService.prototype.addNamedPolicy = function (ptype) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).addNamedPolicy.apply(_a, __spreadArrays([ptype], params));
    };
    AuthZManagementService.prototype.addNamedPolicies = function (ptype, rules) {
        return this.enforcer.addNamedPolicies(ptype, rules);
    };
    AuthZManagementService.prototype.updatePolicy = function (oldRule, newRule) {
        return this.enforcer.updatePolicy(oldRule, newRule);
    };
    AuthZManagementService.prototype.updateNamedPolicy = function (ptype, oldRule, newRule) {
        return this.enforcer.updateNamedPolicy(ptype, oldRule, newRule);
    };
    AuthZManagementService.prototype.removePolicy = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        return (_a = this.enforcer).removePolicy.apply(_a, params);
    };
    AuthZManagementService.prototype.removePolicies = function (rules) {
        return this.enforcer.removePolicies(rules);
    };
    AuthZManagementService.prototype.removeFilteredPolicy = function (fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            fieldValues[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).removeFilteredPolicy.apply(_a, __spreadArrays([fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.removeNamedPolicy = function (ptype) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).removeNamedPolicy.apply(_a, __spreadArrays([ptype], params));
    };
    AuthZManagementService.prototype.removeNamedPolicies = function (ptype, rules) {
        return this.enforcer.removeNamedPolicies(ptype, rules);
    };
    AuthZManagementService.prototype.removeFilteredNamedPolicy = function (ptype, fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            fieldValues[_i - 2] = arguments[_i];
        }
        return (_a = this.enforcer).removeFilteredNamedPolicy.apply(_a, __spreadArrays([ptype,
            fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.hasGroupingPolicy = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        return (_a = this.enforcer).hasGroupingPolicy.apply(_a, params);
    };
    AuthZManagementService.prototype.hasNamedGroupingPolicy = function (ptype) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).hasNamedGroupingPolicy.apply(_a, __spreadArrays([ptype], params));
    };
    AuthZManagementService.prototype.addGroupingPolicy = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        return (_a = this.enforcer).addGroupingPolicy.apply(_a, params);
    };
    AuthZManagementService.prototype.addGroupingPolicies = function (rules) {
        return this.enforcer.addGroupingPolicies(rules);
    };
    AuthZManagementService.prototype.addNamedGroupingPolicy = function (ptype) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).addNamedGroupingPolicy.apply(_a, __spreadArrays([ptype], params));
    };
    AuthZManagementService.prototype.addNamedGroupingPolicies = function (ptype, rules) {
        return this.enforcer.addNamedGroupingPolicies(ptype, rules);
    };
    AuthZManagementService.prototype.removeGroupingPolicy = function () {
        var _a;
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        return (_a = this.enforcer).removeGroupingPolicy.apply(_a, params);
    };
    AuthZManagementService.prototype.removeGroupingPolicies = function (rules) {
        return this.enforcer.removeGroupingPolicies(rules);
    };
    AuthZManagementService.prototype.removeFilteredGroupingPolicy = function (fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            fieldValues[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).removeFilteredGroupingPolicy.apply(_a, __spreadArrays([fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.removeNamedGroupingPolicy = function (ptype) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).removeNamedGroupingPolicy.apply(_a, __spreadArrays([ptype], params));
    };
    AuthZManagementService.prototype.removeNamedGroupingPolicies = function (ptype, rules) {
        return this.enforcer.removeNamedGroupingPolicies(ptype, rules);
    };
    AuthZManagementService.prototype.removeFilteredNamedGroupingPolicy = function (ptype, fieldIndex) {
        var _a;
        var fieldValues = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            fieldValues[_i - 2] = arguments[_i];
        }
        return (_a = this.enforcer).removeFilteredNamedGroupingPolicy.apply(_a, __spreadArrays([ptype,
            fieldIndex], fieldValues));
    };
    AuthZManagementService.prototype.addFunction = function (name, func) {
        return this.enforcer.addFunction(name, func);
    };
    AuthZManagementService = __decorate([
        common_1.Injectable(),
        __param(0, common_1.Inject(authz_constants_1.AUTHZ_ENFORCER)),
        __metadata("design:paramtypes", [casbin.Enforcer])
    ], AuthZManagementService);
    return AuthZManagementService;
}());
exports.AuthZManagementService = AuthZManagementService;
//# sourceMappingURL=authz-management.service.js.map