"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("@nestjs/common");
var authz_constants_1 = require("../authz.constants");
var casbin = require("casbin");
var AuthZRBACService = (function () {
    function AuthZRBACService(enforcer) {
        this.enforcer = enforcer;
    }
    AuthZRBACService.prototype.getRolesForUser = function (name, domain) {
        return this.enforcer.getRolesForUser(name, domain);
    };
    AuthZRBACService.prototype.getUsersForRole = function (name, domain) {
        return this.enforcer.getUsersForRole(name, domain);
    };
    AuthZRBACService.prototype.hasRoleForUser = function (name, role, domain) {
        return this.enforcer.hasRoleForUser(name, role, domain);
    };
    AuthZRBACService.prototype.addRoleForUser = function (user, role, domain) {
        return this.enforcer.addRoleForUser(user, role, domain);
    };
    AuthZRBACService.prototype.deleteRoleForUser = function (user, role, domain) {
        return this.enforcer.deleteRoleForUser(user, role, domain);
    };
    AuthZRBACService.prototype.deleteRolesForUser = function (user, domain) {
        return this.enforcer.deleteRolesForUser(user, domain);
    };
    AuthZRBACService.prototype.deleteUser = function (user) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.enforcer.deleteUser(user)];
            });
        });
    };
    AuthZRBACService.prototype.deleteRole = function (role) {
        return this.enforcer.deleteRole(role);
    };
    AuthZRBACService.prototype.deletePermission = function () {
        var _a;
        var permission = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            permission[_i] = arguments[_i];
        }
        return (_a = this.enforcer).deletePermission.apply(_a, permission);
    };
    AuthZRBACService.prototype.addPermissionForUser = function (userOrRole) {
        var _a;
        var permission = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            permission[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).addPermissionForUser.apply(_a, __spreadArrays([userOrRole], permission));
    };
    AuthZRBACService.prototype.deletePermissionForUser = function (userOrRole) {
        var _a;
        var permission = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            permission[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).deletePermissionForUser.apply(_a, __spreadArrays([userOrRole], permission));
    };
    AuthZRBACService.prototype.deletePermissionsForUser = function (userOrRole) {
        return this.enforcer.deletePermissionsForUser(userOrRole);
    };
    AuthZRBACService.prototype.getPermissionsForUser = function (userOrRole) {
        return this.enforcer.getPermissionsForUser(userOrRole);
    };
    AuthZRBACService.prototype.hasPermissionForUser = function (user) {
        var _a;
        var permission = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            permission[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).hasPermissionForUser.apply(_a, __spreadArrays([user], permission));
    };
    AuthZRBACService.prototype.getImplicitRolesForUser = function (name) {
        var _a;
        var domain = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            domain[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).getImplicitRolesForUser.apply(_a, __spreadArrays([name], domain));
    };
    AuthZRBACService.prototype.getImplicitPermissionsForUser = function (user) {
        var _a;
        var domain = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            domain[_i - 1] = arguments[_i];
        }
        return (_a = this.enforcer).getImplicitPermissionsForUser.apply(_a, __spreadArrays([user], domain));
    };
    AuthZRBACService.prototype.getImplicitUsersForPermission = function () {
        var _a;
        var permission = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            permission[_i] = arguments[_i];
        }
        return (_a = this.enforcer).getImplicitUsersForPermission.apply(_a, permission);
    };
    AuthZRBACService = __decorate([
        common_1.Injectable(),
        __param(0, common_1.Inject(authz_constants_1.AUTHZ_ENFORCER)),
        __metadata("design:paramtypes", [casbin.Enforcer])
    ], AuthZRBACService);
    return AuthZRBACService;
}());
exports.AuthZRBACService = AuthZRBACService;
//# sourceMappingURL=authz-rbac.service.js.map